/*
 * Copyright 2006 Zack Rusin
 * Copyright 2007 Tungsten Graphics, Inc., Cedar Park, Texas.
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without
 * fee, provided that the above copyright notice appear in all copies
 * and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of
 * David Reveman not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission.
 * David Reveman makes no representations about the suitability of this
 * software for any purpose. It is provided "as is" without express or
 * implied warranty.
 *
 * ZACK RUSIN DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL ZACK RUSIN BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Authors: Alan Hourihane <alanh@tungstengraphics.com>
 *
 * Re-written from original code by Zack Rusin
 * 
 **************************************************************************/

#ifndef GLUCOSE_H
#define GLUCOSE_H

Bool
glucoseCloseScreen (int	  index,
		ScreenPtr pScreen);

Bool
glucoseFinishScreenInit (ScreenPtr pScreen);

Bool
glucoseScreenInit (ScreenPtr pScreen, int flags);

typedef void (*destroyGLXscreenProcPtr)(__GLXscreen *screen);

typedef struct {
    __GLXdrawable *rootDrawable;
    __GLXcontext *rootContext;
    CloseScreenProcPtr CloseScreen;
    DestroyPixmapProcPtr *DestroyPixmap;
    __GLXscreen *screen;
    destroyGLXscreenProcPtr destroyGLXscreen;
    glitz_glucose_screen_info_t *screen_info;
} GLucoseScreenPrivRec, *GLucoseScreenPrivPtr;

extern int glucoseScreenPrivateIndex;
#define GLucoseGetScreenPriv(s)	((GLucoseScreenPrivPtr) \
	dixLookupPrivate(&(s)->devPrivates, glucoseGetScreenPrivateKey()))
#define GLucoseScreenPriv(s)	GLucoseScreenPrivPtr    pGLucoseScr = GLucoseGetScreenPriv(s)

#endif /* GLUCOSE_H */
